/* ups-if.c - UPS interface to GNU demangler. */

/*  Copyright 2001 Ian Edwards
 *
 *  You can do what you like with this source code as long as
 *  you don't try to make money out of it and you include an
 *  unaltered copy of this message (including the copyright).
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#if STDC_HEADERS
#include <stdlib.h>
#endif

#include <demangle.h>

/*
 *  Demangle a GNU C++ function name into a a C++ representation of the name.
 *  Returns NULL or a pointer to a malloc'd string which the caller must free.
 *
 *	char *
 *	gnu_cplus_demangle (const char *mangled, int options);
 */

#if 0
/* COPY THIS CHUNK INTO cplus-dem.c */
/*
 *  Added for UPS.
 *  Entry point to use the gnu demangler to demangle type encodings as used
 *  in cast operators.
 *  Returns NULL or a pointer to a malloc'd string which the caller must free.
 */
char *
gnu_demangle_type (mangled, options)
const char **mangled;
int options;
{
    string decl;
    int success = 0;
    struct work_stuff work[1];
    char *result = NULL;

    memset ((char *) work, 0, sizeof (work));
    work->options = options;
    string_init (&decl);
    success = do_type(work, mangled, &decl);
    result = mop_up (work, &decl, success);
    return result;
}
#endif

PTR
xmalloc (size)
size_t size;
{
    return malloc (size);
}

PTR
xrealloc (ptr, size)
PTR ptr;
size_t size;
{
    return realloc (ptr, size);
}
