#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"

char ups_ci_parse_y_sccsid[] = "@(#)ci_parse.y	1.15 16 Apr 1994 (UKC)";

#include <mtrprog/ifdefs.h>

#include <setjmp.h>
#include <stdio.h>

#include <local/ukcprog.h>

#include "ups.h"
#include "symtab.h"
#include "ci.h"
#include "ci_parse.h"
#include "ci_types.h"
#include "ci_util.h"
#include "ci_decl.h"
#include "ci_func.h"
#include "ci_expr.h"
#include "ci_stm.h"
#include "ci_lex.h"

int yyparse PROTO((void));
int ci_labels_allowed PROTO((void));

static int Switch_level = 0;
static int Loop_level = 0;
/* Dibyendu : 28/12/98
 * Typedef_allowed - for resolving typedef/identifier ambiguity
 * Labels_allowed  - for resolving label/typedef ambiguity
 *                   in bitfield declarations
 */
static bool Typedef_allowed = TRUE;
static bool Labels_allowed = TRUE;
bool Expecting_declarator  = FALSE;	/* Typedef fix : 18/1/99 */

#define YYMAXDEPTH	400
#define YYDEBUG		1

typedef union {
	int undef;
	constant_t *constant;
	statement_t *statement;
	expr_list_t *expr_list;
	expr_t *expr;
	type_t *type;
	class_t class;
	typecode_t typecode;
	qualifiers_t qualifier;
	func_t *function;
	declaration_t *declaration;
	declarator_t *declarator;
	var_t *varlist;
	enum_member_t *enum_member;
	identifier_t *identifier;
	identifier_list_t *identifier_list;
	optype_t optype;
	initexpr_t *initialiser;
	lexinfo_t *lexinfo;
} YYSTYPE;
#define YYERRCODE 256
#define FOR 257
#define BREAK 258
#define CONTINUE 259
#define RETURN 260
#define IF 261
#define ELSE 262
#define WHILE 263
#define DO 264
#define SWITCH 265
#define CASE 266
#define DEFAULT 267
#define GOTO 268
#define SIZEOF 269
#define AUTO 270
#define REGISTER 271
#define STATIC 272
#define EXTERN 273
#define TYPEDEF 274
#define VOID 275
#define CHAR 276
#define SHORT 277
#define INT 278
#define LONG 279
#define FLOAT 280
#define DOUBLE 281
#define SIGNED 282
#define UNSIGNED 283
#define CONST 284
#define VOLATILE 285
#define STRUCT 286
#define UNION 287
#define ENUM 288
#define AND 289
#define TILDE 290
#define NOT 291
#define LESSTHAN 292
#define GREATERTHAN 293
#define XOR 294
#define OR 295
#define PLUS 296
#define MINUS 297
#define SLASH 298
#define PERCENT 299
#define STAR 300
#define DOT 301
#define COLON 302
#define QUERY 303
#define SEMI 304
#define COMMA 305
#define LPAREN 306
#define RPAREN 307
#define LBRACE 308
#define RBRACE 309
#define LBRAC 310
#define RBRAC 311
#define EQUALS 312
#define STAR_EQUALS 313
#define SLASH_EQUALS 314
#define PERCENT_EQUALS 315
#define PLUS_EQUALS 316
#define MINUS_EQUALS 317
#define LSHIFT_EQUALS 318
#define RSHIFT_EQUALS 319
#define AND_EQUALS 320
#define XOR_EQUALS 321
#define OR_EQUALS 322
#define ANDAND 323
#define OROR 324
#define EQEQ 325
#define NOTEQ 326
#define GTEQ 327
#define LESSEQ 328
#define LSHIFT 329
#define RSHIFT 330
#define PLUSPLUS 331
#define MINUSMINUS 332
#define ARROW 333
#define ELLIPSIS 334
#define INTEGER_CONSTANT 335
#define CHARACTER_CONSTANT 336
#define FLOATING_CONSTANT 337
#define STRING_CONSTANT 338
#define IDENTIFIER 339
#define TYPEDEF_NAME 340
#define BADTOK 341
const short yylhs[] = {                                        -1,
    0,    0,    1,    1,   74,    2,   76,    2,   45,   45,
   73,   73,   75,   75,   46,   46,   46,   46,   46,   46,
   69,   69,   69,   69,   69,   66,   66,   66,   66,   66,
   66,   66,   66,   66,   66,   66,   66,    3,    3,   77,
   68,   78,   68,   68,   59,   59,   52,   52,   54,   79,
   54,   53,   53,   48,   47,   47,   47,   47,   56,   80,
   56,   55,   55,   55,   81,   82,   67,   83,   84,   67,
   67,   61,   61,   60,   60,   57,   57,   62,   62,   62,
   62,   62,   62,   62,   64,   64,   64,   64,    4,    4,
   49,   49,   50,   50,   51,   51,   51,   41,   41,   70,
   70,   70,   71,   71,   65,   65,   58,   58,   58,   63,
   63,   63,   63,   63,   63,   63,   63,   63,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,   13,   16,   16,    9,    7,    8,    8,   86,   86,
   85,    6,    6,   17,   17,   87,   15,   88,   18,   89,
   19,   44,   20,   22,   22,   14,   10,   11,   12,   21,
   21,   23,   23,   72,   72,   72,   72,   72,   72,   72,
   72,   72,   72,   72,   24,   24,   25,   26,   26,   27,
   27,   28,   28,   29,   29,   30,   30,   31,   31,   31,
   32,   32,   32,   32,   32,   33,   33,   33,   34,   34,
   34,   35,   35,   35,   35,   36,   36,   37,   37,   37,
   37,   37,   37,   37,   37,   37,   37,   37,   38,   38,
   38,   38,   38,   38,   38,   38,   39,   39,   39,   39,
   42,   42,   43,   43,   40,   40,   40,
};
const short yylen[] = {                                         2,
    1,    2,    1,    1,    0,    4,    0,    5,    1,    2,
    2,    3,    1,    2,    1,    2,    1,    2,    1,    2,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,
    5,    0,    6,    2,    1,    1,    1,    2,    1,    0,
    4,    1,    3,    3,    1,    2,    1,    2,    1,    0,
    4,    1,    2,    3,    0,    0,    6,    0,    0,    7,
    2,    1,    3,    1,    3,    1,    2,    1,    3,    3,
    4,    3,    4,    4,    1,    2,    2,    3,    1,    2,
    1,    3,    1,    3,    2,    1,    2,    1,    3,    1,
    3,    4,    1,    3,    1,    2,    1,    1,    2,    3,
    2,    3,    3,    4,    2,    3,    3,    4,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    3,    4,    3,    2,    2,    2,    3,    0,    1,
    1,    1,    2,    5,    7,    1,    5,    1,    5,    1,
    7,    1,    9,    0,    1,    3,    2,    2,    3,    1,
    3,    1,    3,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    5,    1,    1,    3,    1,
    3,    1,    3,    1,    3,    1,    3,    1,    3,    3,
    1,    3,    3,    3,    3,    1,    3,    3,    1,    3,
    3,    1,    3,    3,    3,    1,    4,    1,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    4,    1,    4,
    4,    3,    6,    3,    2,    2,    1,    1,    1,    3,
    0,    1,    1,    3,    1,    1,    1,
};
const short yydefred[] = {                                      0,
   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
   31,   32,   33,   34,   38,   39,   45,   46,    0,    0,
    0,   78,   37,    0,    1,    3,    0,    0,    0,    9,
    0,    0,    0,    0,   36,   35,    0,    4,   65,    0,
   89,    0,   87,    0,    2,   20,    0,   13,    0,    0,
   11,   49,    0,    0,    0,    0,    0,    0,    0,   18,
   16,    0,   68,   90,   88,   79,    0,    0,   14,    0,
   12,   50,    0,    0,    0,   82,   98,    0,    0,    0,
    0,   93,    0,    0,    0,    0,    0,    0,    0,    0,
   80,    0,    0,  235,  236,  237,  229,  227,  177,  162,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  202,    0,    0,  219,  228,    0,   72,    0,    0,
    6,    0,    0,    0,    0,    0,  100,   53,    0,    0,
    0,   47,    0,    0,    0,   84,    0,    0,   95,   97,
    0,    0,   83,    0,    0,  217,  212,  206,  215,  216,
  213,  214,  211,    0,  160,    0,    0,    0,  209,  210,
   81,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  164,  165,  166,  167,  168,  169,  170,  171,  172,  173,
  174,    0,    0,    0,    0,  225,  226,    0,    0,    0,
    0,    0,  152,    0,    0,    0,    0,  148,  150,  146,
    0,    0,    0,  141,  137,    0,  142,    0,  122,  121,
  130,  131,  129,  119,  128,  124,  120,  123,  125,  126,
  127,    0,    0,    0,    0,    0,    0,    0,    8,   51,
  103,    0,    0,   58,    0,   59,    0,    0,   41,   48,
   56,   99,  115,    0,    0,  111,    0,    0,    0,    0,
   92,   94,    0,    0,  230,    0,  106,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  204,  205,  203,  163,  222,
  233,    0,    0,    0,    0,  224,   75,   73,   67,    0,
  158,  157,    0,    0,    0,    0,    0,    0,  138,  143,
  135,    0,  136,    0,    0,    0,    0,  101,   43,   63,
   54,   60,    0,  116,  110,  112,  117,    0,  113,    0,
  218,  161,  207,    0,  221,    0,  220,    0,   70,  159,
    0,    0,  134,  156,  132,    0,    0,    0,    0,  102,
  104,    0,   64,  118,  114,  176,  234,    0,    0,  133,
    0,    0,    0,    0,   61,  223,    0,    0,  147,  149,
    0,    0,    0,    0,  145,    0,  151,    0,  153,
};
const short yydgoto[] = {                                      24,
   25,   26,   27,   42,  217,  218,  219,  121,  220,  221,
  222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
  232,  233,  155,  100,  101,  102,  103,  104,  105,  106,
  107,  108,  109,  110,  111,  112,  113,  114,  115,  116,
   78,  292,  293,  234,   28,   47,  131,  132,  254,   81,
   82,  133,   52,   53,  246,  247,   30,  255,   31,  118,
  119,   32,  141,   33,  157,   34,   35,   36,   37,  128,
  242,  192,   48,   49,  122,   70,   56,   74,  125,  352,
   62,  201,  120,  300,  235,  123,  236,  237,  238,
};
const short yysindex[] = {                                    651,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -301, -100,
 -107,    0,    0,  651,    0,    0,  837,  837, -233,    0,
 -324, -240, -275,  837,    0,    0,  837,    0,    0, -243,
    0, -100,    0, -227,    0,    0, -233,    0, -219,  837,
    0,    0, -276, -216,    0, -169,  727,  909, -240,    0,
    0, -187,    0,    0,    0,    0, -216,  837,    0, -127,
    0,    0,  921, -112,  329,    0,    0, -177, -105, -148,
 -116,    0,  997, 1049, 1049, 1049, 1049, 1049, 1049,  360,
    0, 1061, 1061,    0,    0,    0,    0,    0,    0,    0,
 -103, -292, -110,  -91,  -69,  -13, -224,  -19,  -94,  -43,
   13,    0,  665,   22,    0,    0,  -30,    0,   -5, -187,
    0,  837,  189,  837, -107,  921,    0,    0,  329,  329,
  -25,    0, -232,  329,  -47,    0,  569,  973,    0,    0,
 -231, -183,    0,  765,  360,    0,    0,    0,    0,    0,
    0,    0,    0,  -48,    0,  -80,   18, 1049,    0,    0,
    0, 1049, 1049, 1049, 1049, 1049, 1049, 1049, 1049, 1049,
 1049, 1049, 1049, 1049, 1049, 1049, 1049, 1049, 1049, 1049,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1049,  -32, 1049, 1049,    0,    0, -297, 1049, -187,
    1,   -5,    0,   25,   33, 1049,   39,    0,    0,    0,
 1049,   58,   47,    0,    0,   86,    0,  242,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   85,   94,  100,  837,  101,  102,  295,    0,    0,
    0, -194, 1126,    0, 1049,    0,  -63,  107,    0,    0,
    0,    0,    0,  103,  104,    0,  105,  799,  985, -231,
    0,    0,  106, 1049,    0,  610,    0, -124, 1049, -111,
 -110,  -91,  -69,  -13, -224,  -19,  -19,  -94,  -94,  -94,
  -94,  -43,  -43,   13,   13,    0,    0,    0,    0,    0,
    0,  110,  118, -272, 1049,    0,    0,    0,    0,  115,
    0,    0,  108, 1049,  126,  295,  125,  295,    0,    0,
    0, 1049,    0, 1049, 1049,  167,  857,    0,    0,    0,
    0,    0, 1049,    0,    0,    0,    0,  124,    0,  123,
    0,    0,    0, 1049,    0, 1049,    0, -237,    0,    0,
  -22,  295,    0,    0,    0,  131,   10,   11,  132,    0,
    0,  -25,    0,    0,    0,    0,    0,   98,  295,    0,
 1049,  295,  295, 1049,    0,    0,  177,  137,    0,    0,
   17,  295, 1049,  139,    0,  144,    0,  295,    0,
};
const short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -95,
    0,    0,    0,    0,    0,    0, -207,  151,    0,    0,
  152,  483,    0,  -83,    0,    0,  -67,    0,    0,  442,
    0,   -4,    0,    0,    0,    0,    0,    0,    0,  153,
    0,    0,    0,  688,  401,    0,    0,    0,  526,    0,
    0,    0,    0,    0,    0,    0,   59,   30,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   51,    0,
  155,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  556, 1824,  513, 1067, 1767, 1721, 1646, 1511, 1385,
 1259,    0, 1217, 1175,    0,    0, -180,    0,  154,    0,
    0,   83,  160,   30,    0,    0,    0,    0,    0, -149,
    0,    0,    0,  -55,    0,    0,    0,    0,    0,    0,
   52,   70,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  158,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  159,    0,    0,    0,    0,    0,    0,
    0,  161,    0,    0,    0,  160,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1127,    0,  160,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  -58,    0,    0,   30,    0,    0,  160,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   66,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   71,
    0,    0,    0,    0,    0,    0,    0,  162,    0,    0,
 1834,  826, 1801, 1790, 1744, 1671, 1696, 1538, 1565, 1592,
 1619, 1427, 1469, 1301, 1343,    0,    0,    0,    0,    0,
    0,    0,  169,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  160,    0,  160,    0,    0,
    0,  160,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  160,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  160,    0,
  160,  160,  160,    0,    0,    0,  136,    0,    0,    0,
    0,  160,  170,    0,    0,    0,    0,  160,    0,
};
const short yygindex[] = {                                      0,
  457,    0,   15,    0,  -92,    0,    0, -115,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -86, -181,  -57,  148, -104,    0,  320,  323,  319,  322,
  324,  213,   92,  130,  208,  -66,   -1,    0,    0,    0,
    0,    0,    0,    0,    0,    3,   53, -119,  -52,    0,
  346,  363,  368,    0,  142,    0,  -21,  -62,    0,  296,
  384,    8, -132,  -18,  367,  -12,    0,    0,    0, -120,
    0,    0,   12,    0,  485,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 2158
const short yytable[] = {                                      44,
   99,   43,   29,  154,   80,  241,   39,   54,  239,  260,
  162,   38,  295,  250,   55,  127,  140,  147,  149,  150,
  151,  152,  153,   65,  303,   67,   29,   71,   72,   46,
   21,  163,  264,  257,   41,   38,   60,   40,  337,   61,
   59,  296,    6,    7,    8,    9,   10,   11,   12,   13,
   14,   15,   16,   17,   18,   19,   64,  139,  154,   79,
  142,   69,  134,   22,   63,   57,   20,  264,  127,   58,
   51,  154,   21,  358,  258,  270,  249,  134,  259,   66,
   99,  146,  148,  148,  148,  148,  148,  148,   68,  130,
  159,  160,   19,  267,  297,   73,   19,   19,   19,   19,
  168,  169,   19,   67,  130,   22,  305,   23,  294,  248,
  317,  286,  287,  288,  318,   44,  134,  134,  142,  313,
  134,  134,  137,  250,   74,  310,  138,  135,   74,  136,
  346,   19,  134,   69,  289,  260,  291,  268,   75,   79,
  320,   99,  156,  130,  130,  316,   79,  130,  130,   59,
   57,  117,   57,   99,  330,   22,   57,   57,  143,  130,
   57,  148,  148,  148,  148,  148,  148,  148,  148,  148,
  148,  148,  148,  148,  148,  148,  148,  148,  148,  368,
  124,  266,  244,   15,   16,  138,  251,   99,  144,   57,
  334,  376,   20,  264,   20,  129,  351,  156,   21,   20,
  137,   99,  333,  165,  138,  328,  332,  161,  338,   85,
   85,   85,  164,  343,   85,  345,   17,  341,  353,   20,
   17,   17,   17,   17,  166,  266,   17,  347,  348,  138,
  134,   22,   15,   22,  174,  175,   15,   15,   15,   15,
  321,  322,   15,   85,   55,  155,   55,  268,  155,  360,
   55,   55,  176,  177,   55,   17,  264,  130,  265,  127,
   79,  278,  279,  280,  281,   99,  367,  148,   79,  369,
  370,   15,  170,  171,   20,  167,  245,  371,  357,  375,
   21,  199,  264,   55,  359,  379,  139,  139,  139,  139,
  139,  252,  139,  139,  139,  139,  139,  139,  139,  200,
   86,   86,   86,  282,  283,   86,  290,  172,  173,  299,
  178,  179,  180,   22,  264,  264,  362,  363,  139,  139,
  139,  264,  193,  374,  269,  139,  139,  194,  301,  139,
  248,  195,  148,  139,   86,  139,  302,  139,  139,  140,
  140,  140,  140,  140,  304,  140,  140,  140,  140,  140,
  140,  140,  196,  197,  198,   96,  108,   96,  108,  306,
  139,  139,   52,   52,  139,  139,  139,  139,  139,   62,
   62,  140,  140,  140,  107,  109,  107,  109,  140,  140,
  276,  277,  140,  284,  285,  307,  140,  308,  140,  264,
  140,  140,  144,  144,  144,  144,  144,  311,  144,  144,
  144,  144,  144,  144,  144,  312,  314,  315,  323,  324,
  325,  340,  331,  140,  140,  326,  335,  140,  140,  140,
  140,  140,  336,  339,  144,  144,  144,  342,  344,  349,
  354,  144,  144,  355,  361,  144,  366,  364,  372,  144,
  373,  144,  377,  144,  144,  203,  204,  205,  206,  207,
  378,  208,  209,  210,  211,  212,  213,   83,    5,   40,
    7,   91,   66,  154,  105,  231,  144,  144,  107,   69,
  144,  144,  144,  144,  144,  232,  154,   84,   85,   86,
   45,  356,  271,  273,   87,   88,  272,  274,   89,  262,
  275,  243,  240,  365,   90,  298,  214,  215,  203,  204,
  205,  206,  207,  202,  208,  209,  210,  211,  212,  213,
   83,  263,   50,    0,    0,    0,    0,    0,    0,   92,
   93,    0,    0,   94,   95,   96,   97,  216,    0,    0,
   84,   85,   86,    0,    0,    0,    0,   87,   88,    0,
    0,   89,    0,    0,    0,    0,    0,   90,    0,  214,
  309,  203,  204,  205,  206,  207,    0,  208,  209,  210,
  211,  212,  213,   83,    0,    0,    0,    0,    0,    0,
    0,    0,   92,   93,    0,    0,   94,   95,   96,   97,
  216,    0,    0,   84,   85,   86,    0,    0,    0,    0,
   87,   88,    0,    0,   89,    0,    0,    0,    0,    0,
   90,    0,  214,    6,    7,    8,    9,   10,   11,   12,
   13,   14,   15,   16,   17,   18,   19,    0,    0,    0,
    0,    0,    0,    0,    0,   92,   93,    0,   83,   94,
   95,   96,   97,  216,    6,    7,    8,    9,   10,   11,
   12,   13,   14,   15,   16,   17,   18,   19,   84,   85,
   86,    0,    0,    0,    0,   87,   88,    0,    0,   89,
    0,    0,    0,    0,    0,   90,    0,    0,   23,    0,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,    0,
   92,   93,    0,    0,   94,   95,   96,   97,   98,   23,
   44,    0,   44,    0,   44,   44,   44,   44,   42,    0,
   44,   71,   71,   71,   71,   71,   71,   71,   71,   71,
   71,   71,   71,   71,   71,   71,   71,   71,   71,   71,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   44,
   44,   71,    0,   71,    0,   71,   71,   71,   71,    0,
    0,   71,   76,   76,   76,   76,   76,   76,   76,   76,
   76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
   76,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   71,   71,    0,    0,   76,    0,   76,   76,    0,   76,
   76,    0,    0,    0,   76,   77,   77,   77,   77,   77,
   77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
   77,   77,   77,   77,  180,  180,  180,  180,    0,  180,
    0,  180,   76,  180,    0,    0,    0,   77,    0,   77,
   77,    0,   77,   77,    0,  180,  180,   77,    1,    2,
    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,
   13,   14,   15,   16,   17,   18,   19,  175,    0,  175,
  175,    0,  175,    0,  175,   77,  175,    0,   20,    0,
    0,    0,    0,    0,  137,  253,    0,    0,  138,    1,
    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,
   12,   13,   14,   15,   16,   17,   18,   19,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   22,   23,   20,
    0,    0,    0,    0,    0,  266,  253,    0,    0,  138,
    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,
   11,   12,   13,   14,   15,   16,   17,   18,   19,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   23,
   20,    0,    0,    0,    0,    0,   21,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,  181,  182,  183,  184,
  185,  186,  187,  188,  189,  190,  191,    0,    0,   22,
   23,   52,   52,    0,    0,   10,    1,    2,    3,    4,
    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
   15,   16,   17,   18,   19,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   10,    0,    0,
    0,    0,    0,   76,    1,    2,    3,    4,    5,    6,
    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,
   17,   18,   19,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   77,   23,    0,    1,    2,
    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,
   13,   14,   15,   16,   17,   18,   19,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  261,    0,
    0,    0,    0,    0,   23,  327,    1,    2,    3,    4,
    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
   15,   16,   17,   18,   19,   83,    0,  181,  181,  181,
  181,    0,  181,    0,  181,    0,  181,    0,   23,    0,
    0,    0,    0,    0,    0,   84,   85,   86,  181,  181,
    0,    0,   87,   88,    0,    0,   89,    0,    0,    0,
    0,    0,   90,    0,  126,  350,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   23,   83,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   92,   93,   83,
    0,   94,   95,   96,   97,   98,    0,   84,   85,   86,
    0,    0,    0,    0,   87,   88,    0,    0,   89,   84,
   85,   86,    0,    0,   90,    0,   87,   88,    0,   91,
   89,    0,    0,    0,    0,    0,   90,    0,  126,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   92,
   93,   83,    0,   94,   95,   96,   97,   98,    0,    0,
    0,   92,   93,   83,    0,   94,   95,   96,   97,   98,
    0,   84,   85,   86,    0,   83,    0,    0,   87,   88,
    0,    0,   89,   84,   85,   86,    0,    0,   90,    0,
   87,   88,    0,  256,   89,   84,   85,   86,    0,    0,
   90,    0,   87,   88,    0,  329,   89,    0,    0,    0,
    0,    0,  145,   92,   93,    0,    0,   94,   95,   96,
   97,   98,    0,    0,    0,   92,   93,   83,    0,   94,
   95,   96,   97,   98,    0,    0,    0,   92,   93,   83,
    0,   94,   95,   96,   97,   98,    0,   84,   85,   86,
    0,    0,    0,    0,   87,   88,    0,    0,   89,   84,
   85,   86,    0,    0,   90,    0,   87,   88,    0,    0,
   89,  182,    0,    0,    0,    0,  158,    0,  182,  182,
  182,  182,    0,  182,    0,  182,    0,  182,    0,   92,
   93,    0,    0,   94,   95,   96,   97,   98,    0,  182,
  182,   92,   93,    0,    0,   94,   95,   96,   97,   98,
    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,
   16,   17,   18,   19,    0,  227,    0,    0,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,    0,  227,
  227,  227,  227,    0,  319,    0,  227,    0,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
    0,    0,    0,  208,    0,   23,  208,  208,  208,  208,
  208,  208,  208,  208,  208,    0,  208,  208,  208,  208,
    0,  208,    0,  208,    0,  208,  208,  208,  208,  208,
  208,  208,  208,  208,  208,  208,  208,  208,  208,  208,
  208,  208,  208,  208,  208,  206,    0,    0,  206,  206,
  206,  206,  206,  206,  206,  206,  206,    0,  206,  206,
  206,  206,    0,  206,    0,  206,    0,  206,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  206,
  206,  206,  206,  206,  206,  206,  206,  199,    0,    0,
  199,  199,  199,  199,  199,  199,    0,    0,    0,    0,
  199,  199,  199,  199,    0,  199,    0,  199,    0,  199,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  199,  199,  199,  199,  199,  199,  199,  199,  200,
    0,    0,  200,  200,  200,  200,  200,  200,    0,    0,
    0,    0,  200,  200,  200,  200,    0,  200,    0,  200,
    0,  200,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  200,  200,  200,  200,  200,  200,  200,
  200,  201,    0,    0,  201,  201,  201,  201,  201,  201,
    0,    0,    0,    0,  201,  201,  201,  201,    0,  201,
    0,  201,    0,  201,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  201,  201,  201,  201,  201,
  201,  201,  201,  196,    0,    0,  196,  196,  196,  196,
    0,    0,    0,    0,    0,    0,  196,  196,  196,  196,
    0,  196,    0,  196,    0,  196,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  196,  196,  196,
  196,  196,  196,  196,  196,  197,    0,    0,  197,  197,
  197,  197,    0,    0,    0,    0,    0,    0,  197,  197,
  197,  197,    0,  197,    0,  197,    0,  197,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  197,
  197,  197,  197,  197,  197,  197,  197,  198,    0,    0,
  198,  198,  198,  198,    0,    0,    0,    0,    0,    0,
  198,  198,  198,  198,    0,  198,    0,  198,    0,  198,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  198,  198,  198,  198,  198,  198,  198,  198,  191,
    0,    0,  191,  191,  191,  191,    0,    0,    0,    0,
    0,    0,  191,  191,  191,  191,    0,  191,    0,  191,
    0,  191,    0,    0,    0,    0,  192,    0,    0,  192,
  192,  192,  192,  191,  191,  191,  191,  191,  191,  192,
  192,  192,  192,    0,  192,    0,  192,    0,  192,    0,
    0,    0,    0,  193,    0,    0,  193,  193,  193,  193,
  192,  192,  192,  192,  192,  192,  193,  193,  193,  193,
    0,  193,    0,  193,    0,  193,    0,    0,    0,    0,
  195,    0,    0,  195,  195,  195,  195,  193,  193,  193,
  193,  193,  193,  195,  195,  195,  195,    0,  195,    0,
  195,    0,  195,    0,    0,    0,    0,  194,    0,    0,
  194,  194,  194,  194,  195,  195,  195,  195,  195,  195,
  194,  194,  194,  194,    0,  194,    0,  194,    0,  194,
    0,    0,    0,    0,  188,    0,    0,    0,    0,  188,
  188,  194,  194,  194,  194,  194,  194,  188,  188,  188,
  188,    0,  188,    0,  188,    0,  188,    0,    0,  189,
    0,    0,    0,    0,  189,  189,    0,    0,  188,  188,
  188,  188,  189,  189,  189,  189,    0,  189,    0,  189,
    0,  189,    0,    0,  190,    0,    0,    0,    0,  190,
  190,    0,    0,  189,  189,  189,  189,  190,  190,  190,
  190,    0,  190,    0,  190,    0,  190,    0,    0,  186,
    0,    0,    0,    0,  186,  186,    0,    0,  190,  190,
  190,  190,  186,  186,  186,  186,    0,  186,    0,  186,
    0,  186,  187,    0,    0,    0,    0,  187,  187,    0,
    0,    0,    0,  186,  186,  187,  187,  187,  187,    0,
  187,    0,  187,    0,  187,    0,    0,    0,    0,    0,
  184,  184,    0,    0,    0,    0,  187,  187,  184,  184,
  184,  184,    0,  184,    0,  184,    0,  184,    0,    0,
    0,    0,    0,  185,  185,    0,    0,    0,    0,  184,
  184,  185,  185,  185,  185,  183,  185,    0,  185,    0,
  185,    0,  183,  183,  183,  183,    0,  183,    0,  183,
    0,  183,  185,  185,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  183,  183,  178,  178,  178,  178,    0,
  178,    0,  178,    0,  178,  179,  179,  179,  179,    0,
  179,    0,  179,    0,  179,    0,    0,  178,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  179,
};
const short yycheck[] = {                                      21,
   58,   20,    0,   90,   57,  126,  308,   29,  124,  142,
  303,    0,  310,  133,  339,   73,   79,   84,   85,   86,
   87,   88,   89,   42,  206,   47,   24,  304,  305,   27,
  306,  324,  305,  138,   20,   24,   34,  339,  311,   37,
   33,  339,  275,  276,  277,  278,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,   42,   79,  145,   57,
   79,   50,   75,  339,  308,  306,  300,  305,  126,  310,
  304,  158,  306,  311,  306,  162,  309,   90,  310,  307,
  138,   83,   84,   85,   86,   87,   88,   89,  308,   75,
   92,   93,  300,  156,  199,  312,  304,  305,  306,  307,
  325,  326,  310,  125,   90,  339,  211,  340,  195,  131,
  305,  178,  179,  180,  309,  137,  129,  130,  137,  235,
  133,  134,  306,  243,  305,  218,  310,  305,  309,  307,
  312,  339,  145,  122,  192,  268,  194,  156,  308,  137,
  245,  199,   90,  129,  130,  238,  144,  133,  134,  142,
  300,  339,  302,  211,  259,  339,  306,  307,  307,  145,
  310,  163,  164,  165,  166,  167,  168,  169,  170,  171,
  172,  173,  174,  175,  176,  177,  178,  179,  180,  361,
  308,  306,  130,  284,  285,  310,  134,  245,  305,  339,
  302,  373,  300,  305,  300,  308,  317,  145,  306,  300,
  306,  259,  269,  295,  310,  258,  264,  311,  295,  305,
  306,  307,  323,  306,  310,  308,  300,  304,  323,  300,
  304,  305,  306,  307,  294,  306,  310,  314,  315,  310,
  243,  339,  300,  339,  329,  330,  304,  305,  306,  307,
  304,  305,  310,  339,  300,  304,  302,  266,  307,  342,
  306,  307,  296,  297,  310,  339,  305,  243,  307,  317,
  258,  170,  171,  172,  173,  323,  359,  269,  266,  362,
  363,  339,  292,  293,  300,  289,  302,  364,  336,  372,
  306,  312,  305,  339,  307,  378,  257,  258,  259,  260,
  261,  339,  263,  264,  265,  266,  267,  268,  269,  305,
  305,  306,  307,  174,  175,  310,  339,  327,  328,  309,
  298,  299,  300,  339,  305,  305,  307,  307,  289,  290,
  291,  305,  301,  307,  307,  296,  297,  306,  304,  300,
  352,  310,  334,  304,  339,  306,  304,  308,  309,  257,
  258,  259,  260,  261,  306,  263,  264,  265,  266,  267,
  268,  269,  331,  332,  333,  305,  305,  307,  307,  302,
  331,  332,  304,  305,  335,  336,  337,  338,  339,  304,
  305,  289,  290,  291,  305,  305,  307,  307,  296,  297,
  168,  169,  300,  176,  177,  339,  304,  302,  306,  305,
  308,  309,  257,  258,  259,  260,  261,  304,  263,  264,
  265,  266,  267,  268,  269,  306,  306,  306,  302,  307,
  307,  304,  307,  331,  332,  311,  307,  335,  336,  337,
  338,  339,  305,  309,  289,  290,  291,  302,  304,  263,
  307,  296,  297,  311,  304,  300,  339,  306,  262,  304,
  304,  306,  304,  308,  309,  257,  258,  259,  260,  261,
  307,  263,  264,  265,  266,  267,  268,  269,  308,  308,
  308,  307,  309,  304,  307,  307,  331,  332,  307,  309,
  335,  336,  337,  338,  339,  307,  307,  289,  290,  291,
   24,  334,  163,  165,  296,  297,  164,  166,  300,  144,
  167,  129,  125,  352,  306,  200,  308,  309,  257,  258,
  259,  260,  261,  120,  263,  264,  265,  266,  267,  268,
  269,  145,   28,   -1,   -1,   -1,   -1,   -1,   -1,  331,
  332,   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,
  289,  290,  291,   -1,   -1,   -1,   -1,  296,  297,   -1,
   -1,  300,   -1,   -1,   -1,   -1,   -1,  306,   -1,  308,
  309,  257,  258,  259,  260,  261,   -1,  263,  264,  265,
  266,  267,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  331,  332,   -1,   -1,  335,  336,  337,  338,
  339,   -1,   -1,  289,  290,  291,   -1,   -1,   -1,   -1,
  296,  297,   -1,   -1,  300,   -1,   -1,   -1,   -1,   -1,
  306,   -1,  308,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  331,  332,   -1,  269,  335,
  336,  337,  338,  339,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,   -1,   -1,   -1,   -1,  296,  297,   -1,   -1,  300,
   -1,   -1,   -1,   -1,   -1,  306,   -1,   -1,  340,   -1,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,   -1,
  331,  332,   -1,   -1,  335,  336,  337,  338,  339,  340,
  300,   -1,  302,   -1,  304,  305,  306,  307,  308,   -1,
  310,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  339,
  340,  300,   -1,  302,   -1,  304,  305,  306,  307,   -1,
   -1,  310,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  339,  340,   -1,   -1,  302,   -1,  304,  305,   -1,  307,
  308,   -1,   -1,   -1,  312,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  302,  303,  304,  305,   -1,  307,
   -1,  309,  340,  311,   -1,   -1,   -1,  302,   -1,  304,
  305,   -1,  307,  308,   -1,  323,  324,  312,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  302,   -1,  304,
  305,   -1,  307,   -1,  309,  340,  311,   -1,  300,   -1,
   -1,   -1,   -1,   -1,  306,  307,   -1,   -1,  310,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  339,  340,  300,
   -1,   -1,   -1,   -1,   -1,  306,  307,   -1,   -1,  310,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  340,
  300,   -1,   -1,   -1,   -1,   -1,  306,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  312,  313,  314,  315,
  316,  317,  318,  319,  320,  321,  322,   -1,   -1,  339,
  340,  304,  305,   -1,   -1,  308,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  340,   -1,   -1,
   -1,   -1,   -1,  307,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  339,  340,   -1,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  334,   -1,
   -1,   -1,   -1,   -1,  340,  307,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  269,   -1,  302,  303,  304,
  305,   -1,  307,   -1,  309,   -1,  311,   -1,  340,   -1,
   -1,   -1,   -1,   -1,   -1,  289,  290,  291,  323,  324,
   -1,   -1,  296,  297,   -1,   -1,  300,   -1,   -1,   -1,
   -1,   -1,  306,   -1,  308,  309,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  340,  269,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  331,  332,  269,
   -1,  335,  336,  337,  338,  339,   -1,  289,  290,  291,
   -1,   -1,   -1,   -1,  296,  297,   -1,   -1,  300,  289,
  290,  291,   -1,   -1,  306,   -1,  296,  297,   -1,  311,
  300,   -1,   -1,   -1,   -1,   -1,  306,   -1,  308,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  331,
  332,  269,   -1,  335,  336,  337,  338,  339,   -1,   -1,
   -1,  331,  332,  269,   -1,  335,  336,  337,  338,  339,
   -1,  289,  290,  291,   -1,  269,   -1,   -1,  296,  297,
   -1,   -1,  300,  289,  290,  291,   -1,   -1,  306,   -1,
  296,  297,   -1,  311,  300,  289,  290,  291,   -1,   -1,
  306,   -1,  296,  297,   -1,  311,  300,   -1,   -1,   -1,
   -1,   -1,  306,  331,  332,   -1,   -1,  335,  336,  337,
  338,  339,   -1,   -1,   -1,  331,  332,  269,   -1,  335,
  336,  337,  338,  339,   -1,   -1,   -1,  331,  332,  269,
   -1,  335,  336,  337,  338,  339,   -1,  289,  290,  291,
   -1,   -1,   -1,   -1,  296,  297,   -1,   -1,  300,  289,
  290,  291,   -1,   -1,  306,   -1,  296,  297,   -1,   -1,
  300,  295,   -1,   -1,   -1,   -1,  306,   -1,  302,  303,
  304,  305,   -1,  307,   -1,  309,   -1,  311,   -1,  331,
  332,   -1,   -1,  335,  336,  337,  338,  339,   -1,  323,
  324,  331,  332,   -1,   -1,  335,  336,  337,  338,  339,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,   -1,  289,   -1,   -1,  292,  293,
  294,  295,  296,  297,  298,  299,  300,  301,   -1,  303,
  304,  305,  306,   -1,  309,   -1,  310,   -1,  312,  313,
  314,  315,  316,  317,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,  331,  332,  333,
   -1,   -1,   -1,  289,   -1,  340,  292,  293,  294,  295,
  296,  297,  298,  299,  300,   -1,  302,  303,  304,  305,
   -1,  307,   -1,  309,   -1,  311,  312,  313,  314,  315,
  316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,  289,   -1,   -1,  292,  293,
  294,  295,  296,  297,  298,  299,  300,   -1,  302,  303,
  304,  305,   -1,  307,   -1,  309,   -1,  311,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  323,
  324,  325,  326,  327,  328,  329,  330,  289,   -1,   -1,
  292,  293,  294,  295,  296,  297,   -1,   -1,   -1,   -1,
  302,  303,  304,  305,   -1,  307,   -1,  309,   -1,  311,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  323,  324,  325,  326,  327,  328,  329,  330,  289,
   -1,   -1,  292,  293,  294,  295,  296,  297,   -1,   -1,
   -1,   -1,  302,  303,  304,  305,   -1,  307,   -1,  309,
   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  323,  324,  325,  326,  327,  328,  329,
  330,  289,   -1,   -1,  292,  293,  294,  295,  296,  297,
   -1,   -1,   -1,   -1,  302,  303,  304,  305,   -1,  307,
   -1,  309,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  323,  324,  325,  326,  327,
  328,  329,  330,  289,   -1,   -1,  292,  293,  294,  295,
   -1,   -1,   -1,   -1,   -1,   -1,  302,  303,  304,  305,
   -1,  307,   -1,  309,   -1,  311,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  323,  324,  325,
  326,  327,  328,  329,  330,  289,   -1,   -1,  292,  293,
  294,  295,   -1,   -1,   -1,   -1,   -1,   -1,  302,  303,
  304,  305,   -1,  307,   -1,  309,   -1,  311,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  323,
  324,  325,  326,  327,  328,  329,  330,  289,   -1,   -1,
  292,  293,  294,  295,   -1,   -1,   -1,   -1,   -1,   -1,
  302,  303,  304,  305,   -1,  307,   -1,  309,   -1,  311,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  323,  324,  325,  326,  327,  328,  329,  330,  289,
   -1,   -1,  292,  293,  294,  295,   -1,   -1,   -1,   -1,
   -1,   -1,  302,  303,  304,  305,   -1,  307,   -1,  309,
   -1,  311,   -1,   -1,   -1,   -1,  289,   -1,   -1,  292,
  293,  294,  295,  323,  324,  325,  326,  327,  328,  302,
  303,  304,  305,   -1,  307,   -1,  309,   -1,  311,   -1,
   -1,   -1,   -1,  289,   -1,   -1,  292,  293,  294,  295,
  323,  324,  325,  326,  327,  328,  302,  303,  304,  305,
   -1,  307,   -1,  309,   -1,  311,   -1,   -1,   -1,   -1,
  289,   -1,   -1,  292,  293,  294,  295,  323,  324,  325,
  326,  327,  328,  302,  303,  304,  305,   -1,  307,   -1,
  309,   -1,  311,   -1,   -1,   -1,   -1,  289,   -1,   -1,
  292,  293,  294,  295,  323,  324,  325,  326,  327,  328,
  302,  303,  304,  305,   -1,  307,   -1,  309,   -1,  311,
   -1,   -1,   -1,   -1,  289,   -1,   -1,   -1,   -1,  294,
  295,  323,  324,  325,  326,  327,  328,  302,  303,  304,
  305,   -1,  307,   -1,  309,   -1,  311,   -1,   -1,  289,
   -1,   -1,   -1,   -1,  294,  295,   -1,   -1,  323,  324,
  325,  326,  302,  303,  304,  305,   -1,  307,   -1,  309,
   -1,  311,   -1,   -1,  289,   -1,   -1,   -1,   -1,  294,
  295,   -1,   -1,  323,  324,  325,  326,  302,  303,  304,
  305,   -1,  307,   -1,  309,   -1,  311,   -1,   -1,  289,
   -1,   -1,   -1,   -1,  294,  295,   -1,   -1,  323,  324,
  325,  326,  302,  303,  304,  305,   -1,  307,   -1,  309,
   -1,  311,  289,   -1,   -1,   -1,   -1,  294,  295,   -1,
   -1,   -1,   -1,  323,  324,  302,  303,  304,  305,   -1,
  307,   -1,  309,   -1,  311,   -1,   -1,   -1,   -1,   -1,
  294,  295,   -1,   -1,   -1,   -1,  323,  324,  302,  303,
  304,  305,   -1,  307,   -1,  309,   -1,  311,   -1,   -1,
   -1,   -1,   -1,  294,  295,   -1,   -1,   -1,   -1,  323,
  324,  302,  303,  304,  305,  295,  307,   -1,  309,   -1,
  311,   -1,  302,  303,  304,  305,   -1,  307,   -1,  309,
   -1,  311,  323,  324,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  323,  324,  302,  303,  304,  305,   -1,
  307,   -1,  309,   -1,  311,  302,  303,  304,  305,   -1,
  307,   -1,  309,   -1,  311,   -1,   -1,  324,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  324,
};
#define YYFINAL 24
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 341
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"FOR","BREAK","CONTINUE","RETURN",
"IF","ELSE","WHILE","DO","SWITCH","CASE","DEFAULT","GOTO","SIZEOF","AUTO",
"REGISTER","STATIC","EXTERN","TYPEDEF","VOID","CHAR","SHORT","INT","LONG",
"FLOAT","DOUBLE","SIGNED","UNSIGNED","CONST","VOLATILE","STRUCT","UNION","ENUM",
"AND","TILDE","NOT","LESSTHAN","GREATERTHAN","XOR","OR","PLUS","MINUS","SLASH",
"PERCENT","STAR","DOT","COLON","QUERY","SEMI","COMMA","LPAREN","RPAREN",
"LBRACE","RBRACE","LBRAC","RBRAC","EQUALS","STAR_EQUALS","SLASH_EQUALS",
"PERCENT_EQUALS","PLUS_EQUALS","MINUS_EQUALS","LSHIFT_EQUALS","RSHIFT_EQUALS",
"AND_EQUALS","XOR_EQUALS","OR_EQUALS","ANDAND","OROR","EQEQ","NOTEQ","GTEQ",
"LESSEQ","LSHIFT","RSHIFT","PLUSPLUS","MINUSMINUS","ARROW","ELLIPSIS",
"INTEGER_CONSTANT","CHARACTER_CONSTANT","FLOATING_CONSTANT","STRING_CONSTANT",
"IDENTIFIER","TYPEDEF_NAME","BADTOK",
};
const char * const yyrule[] = {
"$accept : translation_unit",
"translation_unit : external_declaration",
"translation_unit : translation_unit external_declaration",
"external_declaration : function_definition",
"external_declaration : declaration",
"$$1 :",
"function_definition : function_declaration $$1 LBRACE compound_statement_body",
"$$2 :",
"function_definition : function_declaration declaration_list $$2 LBRACE compound_statement_body",
"function_declaration : declarator",
"function_declaration : declaration_specifiers declarator",
"declaration : declaration_specifiers SEMI",
"declaration : declaration_specifiers init_declarator_list SEMI",
"declaration_list : declaration",
"declaration_list : declaration_list declaration",
"declaration_specifiers : storage_class_specifier",
"declaration_specifiers : storage_class_specifier declaration_specifiers",
"declaration_specifiers : type_specifier",
"declaration_specifiers : type_specifier declaration_specifiers",
"declaration_specifiers : type_qualifier",
"declaration_specifiers : type_qualifier declaration_specifiers",
"storage_class_specifier : AUTO",
"storage_class_specifier : REGISTER",
"storage_class_specifier : STATIC",
"storage_class_specifier : EXTERN",
"storage_class_specifier : TYPEDEF",
"type_specifier : VOID",
"type_specifier : CHAR",
"type_specifier : SHORT",
"type_specifier : INT",
"type_specifier : LONG",
"type_specifier : FLOAT",
"type_specifier : DOUBLE",
"type_specifier : SIGNED",
"type_specifier : UNSIGNED",
"type_specifier : struct_or_union_specifier",
"type_specifier : enum_specifier",
"type_specifier : TYPEDEF_NAME",
"type_qualifier : CONST",
"type_qualifier : VOLATILE",
"$$3 :",
"struct_or_union_specifier : struct_or_union $$3 LBRACE struct_declaration_list RBRACE",
"$$4 :",
"struct_or_union_specifier : struct_or_union IDENTIFIER $$4 LBRACE struct_declaration_list RBRACE",
"struct_or_union_specifier : struct_or_union IDENTIFIER",
"struct_or_union : STRUCT",
"struct_or_union : UNION",
"struct_declaration_list : struct_declaration",
"struct_declaration_list : struct_declaration_list struct_declaration",
"init_declarator_list : init_declarator",
"$$5 :",
"init_declarator_list : init_declarator_list COMMA $$5 init_declarator",
"init_declarator : declarator",
"init_declarator : declarator EQUALS initialiser",
"struct_declaration : specifier_qualifier_list struct_declarator_list SEMI",
"specifier_qualifier_list : type_specifier",
"specifier_qualifier_list : type_specifier specifier_qualifier_list",
"specifier_qualifier_list : type_qualifier",
"specifier_qualifier_list : type_qualifier specifier_qualifier_list",
"struct_declarator_list : struct_declarator",
"$$6 :",
"struct_declarator_list : struct_declarator_list COMMA $$6 struct_declarator",
"struct_declarator : declarator",
"struct_declarator : COLON constant_expression",
"struct_declarator : declarator COLON constant_expression",
"$$7 :",
"$$8 :",
"enum_specifier : ENUM LBRACE $$7 enumerator_list $$8 RBRACE",
"$$9 :",
"$$10 :",
"enum_specifier : ENUM IDENTIFIER LBRACE $$9 enumerator_list $$10 RBRACE",
"enum_specifier : ENUM IDENTIFIER",
"enumerator_list : enumerator",
"enumerator_list : enumerator_list COMMA enumerator",
"enumerator : IDENTIFIER",
"enumerator : IDENTIFIER EQUALS constant_expression",
"declarator : direct_declarator",
"declarator : pointer direct_declarator",
"direct_declarator : IDENTIFIER",
"direct_declarator : LPAREN declarator RPAREN",
"direct_declarator : direct_declarator LBRAC RBRAC",
"direct_declarator : direct_declarator LBRAC constant_expression RBRAC",
"direct_declarator : direct_declarator LPAREN RPAREN",
"direct_declarator : direct_declarator LPAREN parameter_type_list RPAREN",
"direct_declarator : direct_declarator LPAREN identifier_list RPAREN",
"pointer : STAR",
"pointer : STAR type_qualifier_list",
"pointer : STAR pointer",
"pointer : STAR type_qualifier_list pointer",
"type_qualifier_list : type_qualifier",
"type_qualifier_list : type_qualifier_list type_qualifier",
"parameter_type_list : parameter_list",
"parameter_type_list : parameter_list COMMA ELLIPSIS",
"parameter_list : parameter_declaration",
"parameter_list : parameter_list COMMA parameter_declaration",
"parameter_declaration : declaration_specifiers declarator",
"parameter_declaration : declaration_specifiers",
"parameter_declaration : declaration_specifiers abstract_declarator",
"identifier_list : IDENTIFIER",
"identifier_list : identifier_list COMMA IDENTIFIER",
"initialiser : assignment_expression",
"initialiser : LBRACE initialiser_list RBRACE",
"initialiser : LBRACE initialiser_list COMMA RBRACE",
"initialiser_list : initialiser",
"initialiser_list : initialiser_list COMMA initialiser",
"type_name : specifier_qualifier_list",
"type_name : specifier_qualifier_list abstract_declarator",
"abstract_declarator : pointer",
"abstract_declarator : direct_abstract_declarator",
"abstract_declarator : pointer direct_abstract_declarator",
"direct_abstract_declarator : LPAREN abstract_declarator RPAREN",
"direct_abstract_declarator : LBRAC RBRAC",
"direct_abstract_declarator : LBRAC constant_expression RBRAC",
"direct_abstract_declarator : direct_abstract_declarator LBRAC RBRAC",
"direct_abstract_declarator : direct_abstract_declarator LBRAC constant_expression RBRAC",
"direct_abstract_declarator : LPAREN RPAREN",
"direct_abstract_declarator : LPAREN parameter_type_list RPAREN",
"direct_abstract_declarator : direct_abstract_declarator LPAREN RPAREN",
"direct_abstract_declarator : direct_abstract_declarator LPAREN parameter_type_list RPAREN",
"statement : labeled_statement",
"statement : case_labeled_statement",
"statement : expression_statement",
"statement : compound_statement",
"statement : if_statement",
"statement : switch_statement",
"statement : while_statement",
"statement : do_statement",
"statement : for_statement",
"statement : goto_statement",
"statement : return_statement",
"statement : continue_statement",
"statement : break_statement",
"labeled_statement : IDENTIFIER COLON statement",
"case_labeled_statement : CASE constant_expression COLON statement",
"case_labeled_statement : DEFAULT COLON statement",
"expression_statement : opt_expression SEMI",
"compound_statement : start_block compound_statement_body",
"compound_statement_body : compound_statement_declarations RBRACE",
"compound_statement_body : compound_statement_declarations statement_list RBRACE",
"compound_statement_declarations :",
"compound_statement_declarations : declaration_list",
"start_block : LBRACE",
"statement_list : statement",
"statement_list : statement_list statement",
"if_statement : IF LPAREN expression RPAREN statement",
"if_statement : IF LPAREN expression RPAREN statement ELSE statement",
"switch : SWITCH",
"switch_statement : switch LPAREN expression RPAREN statement",
"while : WHILE",
"while_statement : while LPAREN expression RPAREN statement",
"do : DO",
"do_statement : do statement WHILE LPAREN expression RPAREN SEMI",
"for : FOR",
"for_statement : for LPAREN opt_expression SEMI opt_expression SEMI opt_expression RPAREN statement",
"opt_expression :",
"opt_expression : expression",
"goto_statement : GOTO IDENTIFIER SEMI",
"continue_statement : CONTINUE SEMI",
"break_statement : BREAK SEMI",
"return_statement : RETURN opt_expression SEMI",
"expression : assignment_expression",
"expression : expression COMMA assignment_expression",
"assignment_expression : conditional_expression",
"assignment_expression : unary_expression assignment_operator assignment_expression",
"assignment_operator : EQUALS",
"assignment_operator : STAR_EQUALS",
"assignment_operator : SLASH_EQUALS",
"assignment_operator : PERCENT_EQUALS",
"assignment_operator : PLUS_EQUALS",
"assignment_operator : MINUS_EQUALS",
"assignment_operator : LSHIFT_EQUALS",
"assignment_operator : RSHIFT_EQUALS",
"assignment_operator : AND_EQUALS",
"assignment_operator : XOR_EQUALS",
"assignment_operator : OR_EQUALS",
"conditional_expression : logical_or_expression",
"conditional_expression : logical_or_expression QUERY expression COLON conditional_expression",
"constant_expression : assignment_expression",
"logical_or_expression : logical_and_expression",
"logical_or_expression : logical_or_expression OROR logical_and_expression",
"logical_and_expression : inclusive_or_expression",
"logical_and_expression : logical_and_expression ANDAND inclusive_or_expression",
"inclusive_or_expression : exclusive_or_expression",
"inclusive_or_expression : inclusive_or_expression OR exclusive_or_expression",
"exclusive_or_expression : and_expression",
"exclusive_or_expression : exclusive_or_expression XOR and_expression",
"and_expression : equality_expression",
"and_expression : and_expression AND equality_expression",
"equality_expression : relational_expression",
"equality_expression : equality_expression EQEQ relational_expression",
"equality_expression : equality_expression NOTEQ relational_expression",
"relational_expression : shift_expression",
"relational_expression : relational_expression LESSTHAN shift_expression",
"relational_expression : relational_expression GREATERTHAN shift_expression",
"relational_expression : relational_expression LESSEQ shift_expression",
"relational_expression : relational_expression GTEQ shift_expression",
"shift_expression : additive_expression",
"shift_expression : shift_expression LSHIFT additive_expression",
"shift_expression : shift_expression RSHIFT additive_expression",
"additive_expression : multiplicative_expression",
"additive_expression : additive_expression PLUS multiplicative_expression",
"additive_expression : additive_expression MINUS multiplicative_expression",
"multiplicative_expression : cast_expression",
"multiplicative_expression : multiplicative_expression STAR cast_expression",
"multiplicative_expression : multiplicative_expression SLASH cast_expression",
"multiplicative_expression : multiplicative_expression PERCENT cast_expression",
"cast_expression : unary_expression",
"cast_expression : LPAREN type_name RPAREN cast_expression",
"unary_expression : postfix_expression",
"unary_expression : PLUSPLUS unary_expression",
"unary_expression : MINUSMINUS unary_expression",
"unary_expression : STAR cast_expression",
"unary_expression : AND cast_expression",
"unary_expression : PLUS cast_expression",
"unary_expression : MINUS cast_expression",
"unary_expression : TILDE cast_expression",
"unary_expression : NOT cast_expression",
"unary_expression : SIZEOF unary_expression",
"unary_expression : SIZEOF LPAREN type_name RPAREN",
"postfix_expression : primary_expression",
"postfix_expression : postfix_expression LBRAC expression RBRAC",
"postfix_expression : postfix_expression LPAREN opt_argument_expression_list RPAREN",
"postfix_expression : postfix_expression DOT IDENTIFIER",
"postfix_expression : postfix_expression ARROW LBRAC expression RBRAC IDENTIFIER",
"postfix_expression : postfix_expression ARROW IDENTIFIER",
"postfix_expression : postfix_expression PLUSPLUS",
"postfix_expression : postfix_expression MINUSMINUS",
"primary_expression : IDENTIFIER",
"primary_expression : constant",
"primary_expression : STRING_CONSTANT",
"primary_expression : LPAREN expression RPAREN",
"opt_argument_expression_list :",
"opt_argument_expression_list : argument_expression_list",
"argument_expression_list : assignment_expression",
"argument_expression_list : argument_expression_list COMMA assignment_expression",
"constant : INTEGER_CONSTANT",
"constant : CHARACTER_CONSTANT",
"constant : FLOATING_CONSTANT",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;

/*  Resolve the C typedef ambiguity - return IDENTIFIER or TYPEDEF_NAME
 *  as the type of the string name.
 */

int
ci_labels_allowed()
{
	/* Labels are not allowed when parsing struct/union/enum types */
	return Labels_allowed;
}

token_t
name_type(name)
const char *name;
{
	/* Typedefs are not allowed when parsing enum constants */
	if (!Typedef_allowed)
		return IDENTIFIER;

	return (ci_lookup_typedef(name) != NULL) ? TYPEDEF_NAME : IDENTIFIER;
}

parse_id_t
ci_parse_file(filename, block, flags, report_error_func,
				resolve_name_func, getline_func, getline_arg)
const char *filename;
block_t *block;
unsigned long flags;
ci_report_error_func_t report_error_func;
ci_resolve_name_func_t resolve_name_func;
const char *(*getline_func)PROTO((char *arg));
char *getline_arg;
{
	lex_env_t lebuf;
	int res;

	lebuf.le_report_func = report_error_func;
	lebuf.le_getline = getline_func;
	lebuf.le_getline_arg = getline_arg;
	lebuf.le_filename = filename;
	lebuf.le_had_error = FALSE;
	lebuf.le_lnum = -1;
	lebuf.le_lptr = "";
	lebuf.le_abort_parse = FALSE;

	Lex_env = &lebuf;
	ci_set_diag_handler(ci_lex_error, (char *)&lebuf);
	ci_start_parse_tree(resolve_name_func, block, flags);
	Loop_level = Switch_level = 0;

	if ((flags & CI_CP_DONT_PANIC) == 0)
		res = yyparse();
	else {
		extern bool ci_Catching_panics;
		extern jmp_buf ci_Catch_panic_env;

		if (ci_Catching_panics)
			panic("catch_panics botch");
		ci_Catching_panics = TRUE;

		if (setjmp(ci_Catch_panic_env) != 0)
			res = -1;
		else
			res = yyparse();

		ci_Catching_panics = FALSE;
	}

	ci_set_diag_handler((diag_handler_func_t)NULL, (char *)NULL);
	Lex_env = NULL;

	/*  We call yylex with Lex_env NULL, to make it put out a newline
	 *  when debugging.
	 */
	(void) yylex();

	return (parse_id_t)ci_end_parse_tree(res == 0 && !lebuf.le_had_error);
}
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc((size_t)newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc((size_t)newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
{
		yyval.undef = 0;
	}
break;
case 2:
{
		yyval.undef = 0;
	}
break;
case 3:
{
		if (Switch_level != 0 || Loop_level != 0)
			ci_panic("level botch in ed");
		yyval.undef = 0;
	}
break;
case 4:
{
		if (Switch_level != 0 || Loop_level != 0)
			ci_panic("level botch in ed");
		yyval.undef = 0;
	}
break;
case 5:
{
		ci_check_func_decls(yyvsp[0].function);
	}
break;
case 6:
{
		ci_end_func(yyvsp[0].statement);
	}
break;
case 7:
{
		ci_check_func_decls(yyvsp[-1].function);
	}
break;
case 8:
{
		ci_end_func(yyvsp[0].statement);
	}
break;
case 9:
{
		declaration_t *dn;

		dn = ci_make_declaration(CL_DECL, ci_code_to_type(TY_INT), 0, yyvsp[0].declarator);
		yyval.function = ci_start_func(dn);
	}
break;
case 10:
{
		declaration_t *dn;

		dn = ci_make_declaration(yyvsp[-1].declaration->dn_class, ci_get_dn_basetype(yyvsp[-1].declaration),
					 yyvsp[-1].declaration->dn_qualifiers, yyvsp[0].declarator);
		yyval.function = ci_start_func(dn);
	}
break;
case 11:
{
		ci_check_declaration(yyvsp[-1].declaration);
	}
break;
case 12:
{
		yyvsp[-2].declaration->dn_declarators = yyvsp[-1].declarator;
		ci_handle_declaration(yyvsp[-2].declaration);
	}
break;
case 15:
{
		yyval.declaration = ci_make_declaration(yyvsp[0].class, (type_t *)NULL, 0,
						(declarator_t *)NULL);
	}
break;
case 16:
{
		ci_set_storage_class(yyvsp[0].declaration, yyvsp[-1].class);
		yyval.declaration = yyvsp[0].declaration;
	}
break;
case 17:
{
		yyval.declaration = ci_make_declaration(CL_NOCLASS, yyvsp[0].type, 0, (declarator_t *)NULL);
	}
break;
case 18:
{
		ci_add_type_specifier(yyvsp[0].declaration, yyvsp[-1].type);
		yyval.declaration = yyvsp[0].declaration;
	}
break;
case 19:
{
		yyval.declaration = ci_make_declaration(CL_NOCLASS, (type_t *)NULL, yyvsp[0].qualifier,
							(declarator_t *)NULL);
	}
break;
case 20:
{
		yyvsp[0].declaration->dn_qualifiers |= yyvsp[-1].qualifier;
		yyval.declaration = yyvsp[0].declaration;
	}
break;
case 21:
{ yyval.class = CL_AUTO;		}
break;
case 22:
{ yyval.class = CL_NOCLASS;	}
break;
case 23:
{ yyval.class = CL_STAT;		}
break;
case 24:
{ yyval.class = CL_DECL;		}
break;
case 25:
{ yyval.class = CL_TYPEDEF;	}
break;
case 26:
{ yyval.type = ci_code_to_type(TY_VOID);	}
break;
case 27:
{ yyval.type = ci_code_to_type(TY_CHAR);	}
break;
case 28:
{ yyval.type = ci_code_to_type(TY_SHORT);	}
break;
case 29:
{ yyval.type = ci_code_to_type(TY_INT);		}
break;
case 30:
{ yyval.type = ci_code_to_type(TY_LONG);	}
break;
case 31:
{ yyval.type = ci_code_to_type(TY_FLOAT);	}
break;
case 32:
{ yyval.type = ci_code_to_type(TY_DOUBLE);	}
break;
case 33:
{ yyval.type = ci_code_to_type(TY_SIGNED);	}
break;
case 34:
{ yyval.type = ci_code_to_type(TY_UNSIGNED);	}
break;
case 35:
{ yyval.type = yyvsp[0].type;				}
break;
case 36:
{ yyval.type = yyvsp[0].type;				}
break;
case 37:
{ yyval.type = ci_lookup_typedef(yyvsp[0].identifier->id_name);
}
break;
case 38:
{ yyval.qualifier = QU_CONST; }
break;
case 39:
{ yyval.qualifier = QU_VOLATILE; }
break;
case 40:
{
		Labels_allowed = FALSE;
	}
break;
case 41:
{
		Labels_allowed = TRUE;
		yyval.type = ci_build_aggr_or_enum_def(yyvsp[-4].typecode, (identifier_t *)NULL,
				AE_COMPLETE, yyvsp[-1].declaration, (enum_member_t *)NULL, FALSE);
	}
break;
case 42:
{
		typecode_t typecode;

		/* Redeclaration Fix : Dibyendu 8/1/99 */
		/*
		 * We now define an incomplete type immediately after we see
		 * the tag (ISO C) - previously this was deferred until we saw
		 * a reference to the tag.
		 * The final argument to ci_build_aggr_or_enum_def() tells it
		 * that although this is an incomplete type the full definition
		 * is about to follow.  This means that this is a new (distinct)
		 * type. See ci_build_aggr_or_enum_def() for more details.
		 */
		typecode = (yyvsp[-1].typecode == TY_STRUCT) ? TY_U_STRUCT : TY_U_UNION;
		ci_build_aggr_or_enum_def(typecode, yyvsp[0].identifier, AE_INCOMPLETE,
					      (declaration_t *)NULL,
					      (enum_member_t *)NULL, TRUE);

		Labels_allowed = FALSE;
	}
break;
case 43:
{
		Labels_allowed = TRUE;
		yyval.type = ci_build_aggr_or_enum_def(yyvsp[-5].typecode, yyvsp[-4].identifier, AE_COMPLETE,
					      yyvsp[-1].declaration, (enum_member_t *)NULL, FALSE);
	}
break;
case 44:
{
		typecode_t typecode;

		typecode = (yyvsp[-1].typecode == TY_STRUCT) ? TY_U_STRUCT : TY_U_UNION;
		yyval.type = ci_build_aggr_or_enum_def(typecode, yyvsp[0].identifier, AE_INCOMPLETE,
					      (declaration_t *)NULL,
					      (enum_member_t *)NULL, FALSE);
	}
break;
case 45:
{ yyval.typecode = TY_STRUCT;	}
break;
case 46:
{ yyval.typecode = TY_UNION;		}
break;
case 47:
{
		yyval.declaration = yyvsp[0].declaration;
	}
break;
case 48:
{
		yyvsp[0].declaration->dn_next = yyvsp[-1].declaration;
		yyval.declaration = yyvsp[0].declaration;
	}
break;
case 49:
{
		yyval.declarator = yyvsp[0].declarator;
	}
break;
case 50:
{
		Expecting_declarator = TRUE;
	}
break;
case 51:
{
		yyvsp[0].declarator->dr_next = yyvsp[-3].declarator;
		yyval.declarator = yyvsp[0].declarator;
	}
break;
case 52:
{
		yyval.declarator = yyvsp[0].declarator;
	}
break;
case 53:
{
		yyvsp[-2].declarator->dr_initialiser = yyvsp[0].initialiser;
		yyval.declarator = yyvsp[-2].declarator;
	}
break;
case 54:
{
		yyval.declaration = ci_make_declaration(yyvsp[-2].declaration->dn_class, ci_get_dn_basetype(yyvsp[-2].declaration),
					 yyvsp[-2].declaration->dn_qualifiers, yyvsp[-1].declarator);
	}
break;
case 55:
{
		yyval.declaration = ci_make_declaration(CL_NOCLASS, yyvsp[0].type, 0, (declarator_t *)NULL);
	}
break;
case 56:
{
		ci_add_type_specifier(yyvsp[0].declaration, yyvsp[-1].type);
		yyval.declaration = yyvsp[0].declaration;
	}
break;
case 57:
{
		yyval.declaration = ci_make_declaration(CL_NOCLASS, (type_t *)NULL, yyvsp[0].qualifier,
							(declarator_t *)NULL);
	}
break;
case 58:
{
		yyvsp[0].declaration->dn_qualifiers |= yyvsp[-1].qualifier;
		yyval.declaration = yyvsp[0].declaration;
	}
break;
case 59:
{
		yyval.declarator = yyvsp[0].declarator;
	}
break;
case 60:
{
		Expecting_declarator = TRUE;
	}
break;
case 61:
{
		yyvsp[0].declarator->dr_next = yyvsp[-3].declarator;
		yyval.declarator = yyvsp[0].declarator;
	}
break;
case 62:
{
		yyval.declarator = yyvsp[0].declarator;
	}
break;
case 63:
{
		yyval.declarator = ci_make_declarator(ci_make_expr_bitfield_type((type_t *)NULL,
									       yyvsp[0].expr));
	}
break;
case 64:
{
		yyval.declarator = ci_make_declarator(ci_make_expr_bitfield_type(yyvsp[-2].declarator->dr_type, yyvsp[0].expr));
	}
break;
case 65:
{
		Typedef_allowed = FALSE;
	}
break;
case 66:
{
		Typedef_allowed = TRUE;
	}
break;
case 67:
{
		yyval.type = ci_build_aggr_or_enum_def(TY_ENUM, (identifier_t *)NULL,
					   AE_COMPLETE,
					   (declaration_t *)NULL, yyvsp[-2].enum_member, FALSE);
	}
break;
case 68:
{
		Typedef_allowed = FALSE;
	}
break;
case 69:
{
		Typedef_allowed = TRUE;
	}
break;
case 70:
{
		yyval.type = ci_build_aggr_or_enum_def(TY_ENUM, yyvsp[-5].identifier,
					   AE_COMPLETE,
					   (declaration_t *)NULL, yyvsp[-2].enum_member, FALSE);
	}
break;
case 71:
{
		yyval.type = ci_build_aggr_or_enum_def(TY_U_ENUM, yyvsp[0].identifier,
					   AE_INCOMPLETE,
					   (declaration_t *)NULL,
					   (enum_member_t *)NULL, FALSE);
	}
break;
case 72:
{
		if (yyvsp[0].enum_member->em_expr_id == NULL)
			yyvsp[0].enum_member->em_val = 0;
		yyvsp[0].enum_member->em_next = NULL;
		yyval.enum_member = yyvsp[0].enum_member;
	}
break;
case 73:
{
		if (yyvsp[0].enum_member->em_expr_id == NULL)
			yyvsp[0].enum_member->em_val = yyvsp[-2].enum_member->em_val + 1;
		yyvsp[0].enum_member->em_next = yyvsp[-2].enum_member;
		yyval.enum_member = yyvsp[0].enum_member;
	}
break;
case 74:
{
		yyval.enum_member = ci_build_enum_member(yyvsp[0].identifier, (expr_t *)NULL);
	}
break;
case 75:
{
		yyval.enum_member = ci_build_enum_member(yyvsp[-2].identifier, yyvsp[0].expr);
	}
break;
case 76:
{
		yyval.declarator = ci_make_declarator(yyvsp[0].type);
	}
break;
case 77:
{
		type_t *ptype;

		ptype = ci_push_types(yyvsp[0].type, yyvsp[-1].type);
		yyval.declarator = ci_make_declarator(ptype);
	}
break;
case 78:
{
		type_t *type;

		Expecting_declarator = FALSE;
		type = ci_make_type(Parse_apool, TY_IDENTIFIER);
		type->ty_identifier = yyvsp[0].identifier;
		yyval.type = type;
	}
break;
case 79:
{
		yyval.type = yyvsp[-1].declarator->dr_type;
	}
break;
case 80:
{
		yyval.type = ci_make_array_type(yyvsp[-2].type, (expr_t *)NULL);
	}
break;
case 81:
{
		yyval.type = ci_make_array_type(yyvsp[-3].type, yyvsp[-1].expr);
	}
break;
case 82:
{
		yyval.type = ci_make_funcret_type(yyvsp[-2].type, FDT_IDLIST, (declaration_t *)NULL,
							(identifier_list_t *)NULL);
	}
break;
case 83:
{
		yyval.type = ci_make_funcret_type(yyvsp[-3].type, FDT_TYPELIST, yyvsp[-1].declaration,
							(identifier_list_t *)NULL);
	}
break;
case 84:
{
		yyval.type = ci_make_funcret_type(yyvsp[-3].type, FDT_IDLIST,
			(declaration_t *)NULL, yyvsp[-1].identifier_list);
	}
break;
case 85:
{
		yyval.type = ci_make_pointer((type_t *)NULL, 0);
	}
break;
case 86:
{
		yyval.type = ci_make_pointer((type_t *)NULL, yyvsp[0].qualifier);
	}
break;
case 87:
{
		yyval.type = ci_make_pointer(yyvsp[0].type, 0);
	}
break;
case 88:
{
		yyval.type = ci_make_pointer(yyvsp[0].type, yyvsp[-1].qualifier);
	}
break;
case 89:
{
		yyval.qualifier = yyvsp[0].qualifier;
	}
break;
case 90:
{
		yyval.qualifier = yyvsp[-1].qualifier | yyvsp[0].qualifier;
	}
break;
case 91:
{
		yyval.declaration = yyvsp[0].declaration;
	}
break;
case 92:
{
		declaration_t *dn;

		dn = ci_make_declaration(CL_ARG, ci_code_to_type(TY_ELLIPSIS), 0,
					 ci_make_declarator((type_t *)NULL));
		dn->dn_next = yyvsp[-2].declaration;
		yyval.declaration = dn;
	}
break;
case 93:
{
		yyval.declaration = yyvsp[0].declaration;
	}
break;
case 94:
{
		yyvsp[0].declaration->dn_next = yyvsp[-2].declaration;
		yyval.declaration = yyvsp[0].declaration;
	}
break;
case 95:
{
		yyval.declaration = ci_make_declaration(yyvsp[-1].declaration->dn_class, ci_get_dn_basetype(yyvsp[-1].declaration),
					 yyvsp[-1].declaration->dn_qualifiers, yyvsp[0].declarator);
	}
break;
case 96:
{
		yyval.declaration = ci_make_declaration(yyvsp[0].declaration->dn_class, ci_get_dn_basetype(yyvsp[0].declaration),
					 yyvsp[0].declaration->dn_qualifiers,
					 ci_make_declarator((type_t *)NULL));
	}
break;
case 97:
{
		yyval.declaration = ci_make_declaration(yyvsp[-1].declaration->dn_class, ci_get_dn_basetype(yyvsp[-1].declaration),
					 yyvsp[-1].declaration->dn_qualifiers, yyvsp[0].declarator);
	}
break;
case 98:
{
		identifier_list_t *idl = NEW(identifier_list_t);

		idl->idl_id = yyvsp[0].identifier;
		idl->idl_next = NULL;
		yyval.identifier_list = idl;
	}
break;
case 99:
{
		identifier_list_t *idl = NEW(identifier_list_t);

		idl->idl_id = yyvsp[0].identifier;
		idl->idl_next = yyvsp[-2].identifier_list;
		yyval.identifier_list = idl;
	}
break;
case 100:
{
		yyval.initialiser = ci_make_initexpr(FALSE, yyvsp[0].expr, (initexpr_t *)NULL);
	}
break;
case 101:
{
		yyval.initialiser = ci_make_initexpr(TRUE, (expr_t *)NULL, yyvsp[-1].initialiser);
	}
break;
case 102:
{
		yyval.initialiser = ci_make_initexpr(TRUE, (expr_t *)NULL, yyvsp[-2].initialiser);
	}
break;
case 103:
{
		yyval.initialiser = yyvsp[0].initialiser;
	}
break;
case 104:
{
		yyvsp[0].initialiser->ie_next = yyvsp[-2].initialiser;
		yyval.initialiser = yyvsp[0].initialiser;
	}
break;
case 105:
{
		yyval.type = ci_get_dn_basetype(yyvsp[0].declaration);
	}
break;
case 106:
{
		yyval.type = ci_push_types(ci_get_dn_basetype(yyvsp[-1].declaration), yyvsp[0].declarator->dr_type);
	}
break;
case 107:
{
		yyval.declarator = ci_make_declarator(yyvsp[0].type);
	}
break;
case 108:
{
		yyval.declarator = ci_make_declarator(yyvsp[0].type);
	}
break;
case 109:
{
		yyvsp[-1].type->ty_base = yyvsp[0].type;
		yyval.declarator = ci_make_declarator(yyvsp[-1].type);
	}
break;
case 110:
{
		yyval.type = yyvsp[-1].declarator->dr_type;
	}
break;
case 111:
{
		yyval.type = ci_make_array_type((type_t *)NULL, (expr_t *)NULL);
	}
break;
case 112:
{
		yyval.type = ci_make_array_type((type_t *)NULL, yyvsp[-1].expr);
	}
break;
case 113:
{
		yyval.type = ci_make_array_type(yyvsp[-2].type, (expr_t *)NULL);
	}
break;
case 114:
{
		yyval.type = ci_make_array_type(yyvsp[-3].type, yyvsp[-1].expr);
	}
break;
case 115:
{
		yyval.type = ci_make_funcret_type((type_t *)NULL, FDT_IDLIST,
						(declaration_t *)NULL,
						(identifier_list_t *)NULL);
	}
break;
case 116:
{
		yyval.type = ci_make_funcret_type((type_t *)NULL, FDT_TYPELIST, yyvsp[-1].declaration,
						(identifier_list_t *)NULL);
	}
break;
case 117:
{
		yyval.type = ci_make_funcret_type(yyvsp[-2].type, FDT_IDLIST, (declaration_t *)NULL,
						(identifier_list_t *)NULL);
	}
break;
case 118:
{
		yyval.type = ci_make_funcret_type(yyvsp[-3].type, FDT_TYPELIST, yyvsp[-1].declaration,
						(identifier_list_t *)NULL);
	}
break;
case 132:
{
		yyval.statement = ci_make_labeled_statement(yyvsp[-2].identifier, yyvsp[0].statement);
	}
break;
case 133:
{
		yyval.statement = ci_make_case_labeled_statement(Switch_level != 0, yyvsp[-2].expr, yyvsp[0].statement);
	}
break;
case 134:
{
		yyval.statement = ci_make_case_labeled_statement(Switch_level != 0,
								(expr_t *)NULL, yyvsp[0].statement);
	}
break;
case 135:
{
		yyval.statement = ci_make_expression_statement(yyvsp[-1].expr);
	}
break;
case 136:
{
		yyval.statement = yyvsp[0].statement;
	}
break;
case 137:
{
		yyval.statement = ci_end_compound_statement((statement_t *)NULL);
	}
break;
case 138:
{
		yyval.statement = ci_end_compound_statement(yyvsp[-1].statement);
	}
break;
case 141:
{
		ci_start_block(TRUE);
	}
break;
case 142:
{
		yyvsp[0].statement->st_next = NULL;
		yyval.statement = yyvsp[0].statement;
	}
break;
case 143:
{
		yyvsp[0].statement->st_next = yyvsp[-1].statement;
		yyval.statement = yyvsp[0].statement;
	}
break;
case 144:
{
		yyval.statement = ci_make_if_statement(yyvsp[-2].expr, yyvsp[0].statement, (statement_t *)NULL);
	}
break;
case 145:
{
		yyval.statement = ci_make_if_statement(yyvsp[-4].expr, yyvsp[-2].statement, yyvsp[0].statement);
	}
break;
case 146:
{
		++Switch_level;
	}
break;
case 147:
{
		--Switch_level;
		yyval.statement = ci_make_switch_statement(yyvsp[-2].expr, yyvsp[0].statement);
	}
break;
case 148:
{
		++Loop_level;
	}
break;
case 149:
{
		--Loop_level;
		yyval.statement = ci_make_while_statement(STT_WHILE, yyvsp[-2].expr, yyvsp[0].statement);
	}
break;
case 150:
{
		++Loop_level;
	}
break;
case 151:
{
		--Loop_level;
		yyval.statement = ci_make_while_statement(STT_DO, yyvsp[-2].expr, yyvsp[-5].statement);
	}
break;
case 152:
{
		++Loop_level;
		yyval.lexinfo = yyvsp[0].lexinfo;
	}
break;
case 153:
{
		--Loop_level;
		yyval.statement = ci_make_for_statement(yyvsp[-6].expr, yyvsp[-4].expr, yyvsp[-2].expr, yyvsp[0].statement, yyvsp[-8].lexinfo);
	}
break;
case 154:
{
		yyval.expr = NULL;
	}
break;
case 155:
{
		yyval.expr = yyvsp[0].expr;
	}
break;
case 156:
{
		yyval.statement = ci_make_goto_statement(yyvsp[-1].identifier);
	}
break;
case 157:
{
		yyval.statement = ci_make_continue_statement(Loop_level != 0, yyvsp[-1].lexinfo);
	}
break;
case 158:
{
		yyval.statement = ci_make_break_statement(Loop_level + Switch_level != 0, yyvsp[-1].lexinfo);
	}
break;
case 159:
{
		yyval.statement = ci_make_return_statement(yyvsp[-1].expr, yyvsp[-2].lexinfo);
	}
break;
case 160:
{
		yyval.expr = yyvsp[0].expr;
	}
break;
case 161:
{
		yyval.expr = ci_make_comma_expr(yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 163:
{
		yyval.expr = ci_make_assignment_expr(yyvsp[-1].optype, yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 164:
{ yyval.optype = OP_ASSIGN;		}
break;
case 165:
{ yyval.optype = OP_MUL_ASSIGN;		}
break;
case 166:
{ yyval.optype = OP_DIV_ASSIGN;		}
break;
case 167:
{ yyval.optype = OP_MOD_ASSIGN;		}
break;
case 168:
{ yyval.optype = OP_PLUS_ASSIGN;		}
break;
case 169:
{ yyval.optype = OP_MINUS_ASSIGN;		}
break;
case 170:
{ yyval.optype = OP_LSHIFT_ASSIGN;	}
break;
case 171:
{ yyval.optype = OP_RSHIFT_ASSIGN;	}
break;
case 172:
{ yyval.optype = OP_BITWISE_AND_ASSIGN;	}
break;
case 173:
{ yyval.optype = OP_BITWISE_XOR_ASSIGN;	}
break;
case 174:
{ yyval.optype = OP_BITWISE_OR_ASSIGN;	}
break;
case 176:
{
		yyval.expr = ci_make_conditional_expression(yyvsp[-4].expr, yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 177:
{
		yyval.expr = yyvsp[0].expr;
	}
break;
case 179:
{
		yyval.expr = ci_make_logical_expr(OP_LOGICAL_OR, "||", yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 181:
{
		yyval.expr = ci_make_logical_expr(OP_LOGICAL_AND, "&&", yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 183:
{
		yyval.expr = ci_make_bitwise_expr(OP_BITWISE_OR, "|", yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 185:
{
		yyval.expr = ci_make_bitwise_expr(OP_BITWISE_XOR, "^", yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 187:
{
		yyval.expr = ci_make_bitwise_expr(OP_BITWISE_AND, "&", yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 189:
{
		yyval.expr = ci_make_comparison_expr(OP_IS_EQUAL, "==", yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 190:
{
		yyval.expr = ci_make_comparison_expr(OP_NOT_EQUAL, "!=", yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 192:
{
		yyval.expr = ci_make_comparison_expr(OP_LESS, "<", yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 193:
{
		yyval.expr = ci_make_comparison_expr(OP_GREATER, ">", yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 194:
{
		yyval.expr = ci_make_comparison_expr(OP_LESS_OR_EQUAL, "<=", yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 195:
{
		yyval.expr = ci_make_comparison_expr(OP_GREATER_OR_EQUAL, ">=", yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 197:
{
		yyval.expr = ci_make_shift_expr(OP_LSHIFT, "<<", yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 198:
{
		yyval.expr = ci_make_shift_expr(OP_RSHIFT, ">>", yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 200:
{
		yyval.expr = ci_make_add_or_subtract_expr(OP_PLUS, "+", yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 201:
{
		yyval.expr = ci_make_add_or_subtract_expr(OP_MINUS, "-", yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 203:
{
		yyval.expr = ci_make_mul_or_div_expr(OP_MUL, "*", yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 204:
{
		yyval.expr = ci_make_mul_or_div_expr(OP_DIV, "/", yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 205:
{
		yyval.expr = ci_make_mod_expr(OP_MOD, "%", yyvsp[-2].expr, yyvsp[0].expr);
	}
break;
case 207:
{
		yyval.expr = ci_make_cast_expr(yyvsp[-2].type, yyvsp[0].expr);
	}
break;
case 208:
{
		yyval.expr = yyvsp[0].expr;
	}
break;
case 209:
{
		yyval.expr = ci_make_inc_or_dec_expr(OP_PREINC, yyvsp[0].expr, "prefix ++");
	}
break;
case 210:
{
		yyval.expr = ci_make_inc_or_dec_expr(OP_PREDEC, yyvsp[0].expr, "prefix --");
	}
break;
case 211:
{
		yyval.expr = ci_make_deref_expr(yyvsp[0].expr);
	}
break;
case 212:
{
		yyval.expr = ci_make_address_of_expr(yyvsp[0].expr);
	}
break;
case 213:
{
		yyval.expr = ci_make_unary_plus_expr(yyvsp[0].expr);
	}
break;
case 214:
{
		yyval.expr = ci_make_unary_minus_expr(yyvsp[0].expr);
	}
break;
case 215:
{
		yyval.expr = ci_make_bitwise_not_expr(yyvsp[0].expr);
	}
break;
case 216:
{
		yyval.expr = ci_make_logical_not_expr(yyvsp[0].expr);
	}
break;
case 217:
{
		yyval.expr = ci_make_sizeof_expr(yyvsp[0].expr, (type_t *)NULL);
	}
break;
case 218:
{
		yyval.expr = ci_make_sizeof_expr((expr_t *)NULL, yyvsp[-1].type);
	}
break;
case 220:
{
		/*  Rewrite as *($1 + $3).
		 */
		yyval.expr = ci_make_deref_expr(ci_make_add_or_subtract_expr(OP_PLUS, "+",
									   yyvsp[-3].expr, yyvsp[-1].expr));
	}
break;
case 221:
{
		yyval.expr = ci_make_func_call_expr(yyvsp[-3].expr, yyvsp[-1].expr_list);
	}
break;
case 222:
{
		yyval.expr = ci_make_dot_expr(yyvsp[-2].expr, yyvsp[0].identifier, "dot");
	}
break;
case 223:
{
		yyval.expr = ci_make_multi_arrow_expr(yyvsp[-5].expr, yyvsp[-2].expr, yyvsp[0].identifier);
	}
break;
case 224:
{
		/*  Rewrite as (*$1).$3
		 */
		yyval.expr = ci_make_dot_expr(ci_make_deref_expr(yyvsp[-2].expr), yyvsp[0].identifier, "arrow");
	}
break;
case 225:
{
		yyval.expr = ci_make_inc_or_dec_expr(OP_POSTINC, yyvsp[-1].expr, "postfix ++");
	}
break;
case 226:
{
		yyval.expr = ci_make_inc_or_dec_expr(OP_POSTDEC, yyvsp[-1].expr, "postfix --");
	}
break;
case 227:
{
		yyval.expr = ci_make_identifier_expr(yyvsp[0].identifier);
	}
break;
case 228:
{
		yyval.expr = yyvsp[0].expr;
	}
break;
case 229:
{
		yyval.expr = ci_make_string_constant_expr(yyvsp[0].constant->co_lexinfo,
						  &yyvsp[0].constant->co_string_val);
	}
break;
case 230:
{
		yyval.expr = yyvsp[-1].expr;
	}
break;
case 231:
{
		yyval.expr_list = NULL;
	}
break;
case 232:
{
		yyval.expr_list = yyvsp[0].expr_list;
	}
break;
case 233:
{
		expr_list_t *el = NEW(expr_list_t);

		el->el_expr = yyvsp[0].expr;
		el->el_next = NULL;
		yyval.expr_list = el;
	}
break;
case 234:
{
		expr_list_t *el = NEW(expr_list_t);

		el->el_expr = yyvsp[0].expr;
		el->el_next = yyvsp[-2].expr_list;
		yyval.expr_list = el;
	}
break;
case 235:
{
		yyval.expr = ci_make_integer_constant_expr(ET_INT_CONST,
						   yyvsp[0].constant->co_lexinfo,
						   yyvsp[0].constant->co_integer_val,
						   yyvsp[0].constant->co_is_unsigned,
#if WANT_LL
						   yyvsp[0].constant->co_is_longlong);
#else
						   FALSE);
#endif
	}
break;
case 236:
{
		yyval.expr = ci_make_integer_constant_expr(ET_CHAR_CONST,
						   yyvsp[0].constant->co_lexinfo,
						   yyvsp[0].constant->co_integer_val,
						   FALSE, FALSE);
	}
break;
case 237:
{
		yyval.expr = ci_make_floating_constant_expr(yyvsp[0].constant->co_lexinfo,
						    yyvsp[0].constant->co_floating_val);
	}
break;
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
